Get Google Dataset Info Advanced Results by id

checked GET
Pricing

Your account will be charged only for posting a task. You can get the results of the task within the next 30 days for free.
The cost can be calculated on the Pricing page.

Description of the fields for sending a request:

Field nameTypeDescription
idstring

task identifier
unique task identifier in our system in the UUID format
you will be able to use it within 30 days to request the results of the task at any time


‌‌
‌‌As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

You can also get all available SERP features and possible extra elements by making a request to the following Sandbox URL:
https://sandbox.dataforseo.com/v3/serp/google/dataset_info/task_get/advanced/00000000-0000-0000-0000-000000000000
The response will include all available items in the Google Dataset Info SERP Advanced endpoint with the fields containing dummy data.
You won’t be charged for using Sandbox endpoints.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        keywordstring

keyword received in a POST array
the keyword is returned with decoded %## (plus symbol '+' will be decoded to a space character)

        se_domainstring

search engine domain in a POST array

        language_codestring

language code in a POST array

        check_urlstring

direct URL to search engine results
you can use it to make sure that we provided accurate results

        datetimestring

date and time when the result was received
in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”
example:
2019-11-15 12:57:46 +00:00

        spellobject

autocorrection of the search engine
if the search engine provided results for a keyword that was corrected, we will specify the keyword corrected by the search engine and the type of autocorrection

        refinement_chipsobject

search refinement chips

        item_typesarray

types of search results in SERP
contains types of search results (items) found in SERP.
possible item type: dataset

        se_results_countinteger

total number of results in SERP

        items_countinteger

the number of results returned in the items array

        itemsarray

elements of search results found in SERP

            typestring

type of element = 'dataset'

            rank_groupinteger

group rank in SERP
position within a group of elements with identical type values
positions of elements with different type values are omitted from rank_group

            rank_absoluteinteger

absolute rank in SERP
absolute position among all the elements in SERP

            positionstring

the alignment of the element in SERP
can take the following values:
left, right

            xpathstring

the XPath of the element

            dataset_idstring

ID of the dataset

            titlestring

title of the result in SERP

            image_urlstring

URL of the image
the URL leading to the image on the original resource or DataForSEO storage (in case the original source is not available)

            scholarly_citations_countinteger

count of articles that refer to the dataset

            linksarray

sitelinks
the links shown below some of Google Dataset's search results
if there are none, equals null

                typestring

type of element = 'link_element'

                titlestring

title of the result in SERP

                descriptionstring

description of the results element in SERP

                urlstring

sitelink URL

                domainstring

domain in SERP

            dataset_providersarray

the list of institutions that provided the dataset

                typestring

type of element = 'dataset_providers_element'

                titlestring

name of the dataset provider

                urlstring

site URL of the dataset provider

                domainstring

site domain of the dataset provider

            formatsarray

the list of file formats of the dataset

                typestring

type of element = 'formats_element'

                formatstring

type of file format of the dataset
foe example: zip, html, csv

                sizestring

file size in bytes

            authorsarray

the list of authors of the dataset

                typestring

type of element = 'authors_element'

                namestring

name of the dataset author

                urlstring

author's link URL

                domainstring

author's link domain

            licensesarray

the list of licenses issued to the dataset

                typestring

type of element = 'licenses_element'

                titlestring

name of the license

                urlstring

license URL

                domainstring

domain where an URL points

            updated_datestring

date and time when the result was last updated
in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”
example:
2022-11-27 02:00:00 +00:00

            area_coveredarray

the list of areas covered in the dataset
for example: Africa, Global

            period_coveredobject

period covered in the dataset

                start_datestring

date and time when the period starts
in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”
example:
2020-03-02 02:00:00 +00:00

                end_datestring

date and time when the period ends
in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”
example:
2022-12-09 02:00:00 +00:00

                displayed_datestring

period displayed in SERP
example:
Mar 2, 2020 - Dec 9, 2022

            dataset_descriptionobject

description of the dataset

                textstring

text of the description

                linksarray

links featured in the 'dataset_description'

                    typestring

type of element = 'link_element'

                    titlestring

link anchor text

                    descriptionstring

description of the results element in SERP

                    urlstring

URL link

                    domainstring

domain in SERP


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
id="02261816-2027-0066-0000-c27d02864073" 
curl --location --request GET "https://api.dataforseo.com/v3/serp/google/dataset_info/task_get/advanced/${id}" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw ""
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
	// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
	$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
	exit();
}
try {
	$result = array();
	// #1 - using this method you can get a list of completed tasks
	// GET /v3/serp/google/dataset_info/tasks_ready
	$tasks_ready = $client->get('/v3/serp/google/dataset_info/tasks_ready');
	// you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
	if (isset($tasks_ready['status_code']) AND $tasks_ready['status_code'] === 20000) {
		foreach ($tasks_ready['tasks'] as $task) {
			if (isset($task['result'])) {
				foreach ($task['result'] as $task_ready) {
					// #2 - using this method you can get results of each completed task
					// GET /v3/serp/google/dataset_info/task_get/advanced/$id
					if (isset($task_ready['endpoint_advanced'])) {
						$result[] = $client->get($task_ready['endpoint_advanced']);
					}
					// #3 - another way to get the task results by id
					// GET /v3/serp/google/dataset_info/task_get/advanced/$id
					/*
					if (isset($task_ready['id'])) {
						$result[] = $client->get('/v3/serp/google/dataset_info/task_get/advanced/' . $task_ready['id']);
					}
					*/
				}
			}
		}
	}
	print_r($result);
	// do something with result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
const task_id = '02231256-2604-0066-2000-57133b8fc54e';

const axios = require('axios');

axios({
    method: 'get',
    url: 'https://api.dataforseo.com/v3/serp/google/dataset_info/task_get/advanced/' + task_id,
    auth: {
        username: 'login',
        password: 'password'
    },
    headers: {
        'content-type': 'application/json'
    }
}).then(function (response) {
    var result = response['data']['tasks'];
    // Result data
    console.log(result);
}).catch(function (error) {
    console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
# 1 - using this method you can get a list of completed tasks
# GET /v3/serp/google/dataset_info/tasks_ready
response = client.get("/v3/serp/google/dataset_info/tasks_ready")
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response['status_code'] == 20000:
    results = []
    for task in response['tasks']:
        if (task['result'] and (len(task['result']) > 0)):
            for resultTaskInfo in task['result']:
                # 2 - using this method you can get results of each completed task
                # GET /v3/serp/google/dataset_ifo/task_get/advanced/$id
                if(resultTaskInfo['endpoint_advanced']):
                    results.append(client.get(resultTaskInfo['endpoint_advanced']))                
                '''
                # 3 - another way to get the task results by id
                # GET /v3/serp/google/dataset_info/task_get/advanced/$id                
                if(resultTaskInfo['id']):
                    results.append(client.get("/v3/serp/google/dataset_info/task_get/advanced/" + resultTaskInfo['id']))
                '''
    print(results)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task serp_task_get()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            // #1 - using this method you can get a list of completed tasks
            // GET /v3/serp/google/dataset_info/tasks_ready
            var response = await httpClient.GetAsync("/v3/serp/google/dataset_info/tasks_ready");
            var tasksInfo = JsonConvert.DeserializeObject<dynamic>(await response.Content.ReadAsStringAsync());
            var tasksResponses = new List<object>();
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (tasksInfo.status_code == 20000)
            {
                if (tasksInfo.tasks != null)
                {
                    foreach (var tasks in tasksInfo.tasks)
                    {
                        if (tasks.result != null)
                        {
                            foreach (var task in tasks.result)
                            {
                                if (task.endpoint_advanced != null)
                                {
                                    // #2 - using this method you can get results of each completed task
                                    // GET /v3/serp/google/dataset_info/task_get/advanced/$id
                                    var taskGetResponse = await httpClient.GetAsync((string)task.endpoint_advanced);
                                    var taskResultObj = JsonConvert.DeserializeObject<dynamic>(await taskGetResponse.Content.ReadAsStringAsync());
                                    if (taskResultObj.tasks != null)
                                    {
                                        var fst = taskResultObj.tasks.First;
                                        // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
                                        if (fst.status_code >= 40000 || fst.result == null)
                                            Console.WriteLine($"error. Code: {fst.status_code} Message: {fst.status_message}");
                                        else
                                            tasksResponses.Add(fst.result);
                                    }
                                    // #3 - another way to get the task results by id
                                    // GET /v3/serp/google/dataset_info/task_get/advanced/$id
                                    /*
                                    var tasksGetResponse = await httpClient.GetAsync("/v3/serp/google/dataset_info/task_get/advanced/" + (string)task.id);
                                    var tasksResultObj = JsonConvert.DeserializeObject<dynamic>(await tasksGetResponse.Content.ReadAsStringAsync());
                                    if (tasksResultObj.tasks != null)
                                    {
                                        var fst = taskResultObj.tasks.First;
                                        // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
                                        if (fst.status_code >= 40000 || fst.result == null)
                                            Console.WriteLine($"error. Code: {fst.status_code} Message: {fst.status_message}");
                                        else
                                            tasksResponses.Add(fst.result);
                                    }
                                    */
                                }
                            }
                        }
                    }
                }
                if (tasksResponses.Count > 0)
                    // do something with result
                    Console.WriteLine(String.Join(Environment.NewLine, tasksResponses));
                else
                    Console.WriteLine("No completed tasks");
            }
            else
                Console.WriteLine($"error. Code: {tasksInfo.status_code} Message: {tasksInfo.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20221214",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.0729 sec.",
  "cost": 0,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "12161540-4426-0066-0000-2ae254b4bde6",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "0.0187 sec.",
      "cost": 0,
      "result_count": 1,
      "path": [
        "v3",
        "serp",
        "google",
        "dataset_info",
        "task_get",
        "advanced",
        "12161540-4426-0066-0000-2ae254b4bde6"
      ],
      "data": {
        "api": "serp",
        "function": "task_get",
        "se": "google",
        "se_type": "dataset_info",
        "dataset_id": "L2cvMTFqbl85ZHN6MQ==",
        "device": "desktop",
        "os": "windows"
      },
      "result": [
        {
          "keyword": "L2cvMTFqbl85ZHN6MQ==",
          "se_domain": "datasetsearch.research.google.com",
          "language_code": "en",
          "check_url": "https://datasetsearch.research.google.com/search?docid=L2cvMTFqbl85ZHN6MQ%3D%3D&hl=en",
          "datetime": "2022-12-16 13:41:03 +00:00",
          "spell": null,
          "refinement_chips": null,
          "item_types": [
            "dataset"
          ],
          "se_results_count": 1,
          "items_count": 1,
          "items": [
            {
              "type": "dataset",
              "rank_group": 1,
              "rank_absolute": 1,
              "position": "left",
              "xpath": null,
              "dataset_id": "L2cvMTFqbl85ZHN6MQ==",
              "title": "Water quality in Canadian rivers – Federal data files",
              "image_url": "https://encrypted-tbn3.gstatic.com/images?q=tbn:ANd9GcRSk0xXK2Wz-UFr7EbQBu8SrSbLPM82jfh3zL_BybsBwBiVnIzF",
              "scholarly_citations_count": 1,
              "links": [
                {
                  "type": "link_element",
                  "title": "canada.ca",
                  "description": null,
                  "url": "http://open.canada.ca/",
                  "domain": "open.canada.ca"
                }
              ],
              "dataset_providers": [
                {
                  "type": "dataset_providers_element",
                  "title": "Environment and Climate Change Canada",
                  "url": "http://www.ec.gc.ca/",
                  "domain": "www.ec.gc.ca"
                }
              ],
              "formats": [
                {
                  "type": "formats_element",
                  "format": "html",
                  "size": null
                },
                {
                  "type": "formats_element",
                  "format": "csv",
                  "size": null
                }
              ],
              "authors": null,
              "licenses": [
                {
                  "type": "licenses_element",
                  "title": "Open Government Licence - Canada 2.0",
                  "url": "https://open.canada.ca/en/open-government-licence-canada",
                  "domain": "open.canada.ca"
                }
              ],
              "updated_date": "2019-06-24 03:00:00 +00:00",
              "area_covered": null,
              "period_covered": {
                "start_date": "2002-01-01 02:00:00 +00:00",
                "end_date": "2017-12-31 02:00:00 +00:00",
                "displayed_date": "Jan 1, 2002 - Dec 31, 2017"
              },
              "dataset_description": {
                "text": "The Canadian Environmental Sustainability Indicators (CESI) program provides data and information to track Canada's performance on key environmental sustainability issues. The Water quality in Canadian rivers indicators provide a measure of the ability of river water across Canada to support plants and animals. At each monitoring site, water quality data are compared to water quality guidelines to create a rating for the site. If measured water quality is below the guidelines, it can maintain a healthy ecosystem. Water quality at a monitoring site is considered excellent when parameters in a river very rarely exceed their guidelines. Conversely, water quality is rated poor when parameters usually exceed their guidelines, sometimes by a wide margin. These indicators provide information about the state of surface water quality and its change through time, to support water resource management. Information is provided to Canadians in a number of formats including: static and interactive maps, charts and graphs, HTML and CSV data tables and downloadable reports. See the supplementary documentation for the data sources and details on how the data were collected and how the indicator was calculated. Supplemental Information Canadian Environmental Sustainability Indicators - Home page: https://www.canada.ca/environmental-indicatorsn",
                "links": [
                  {
                    "type": "link_element",
                    "title": "https://www.canada.ca/environmental-indicators",
                    "description": null,
                    "url": "https://www.google.com/url?q=https%3A%2F%2Fwww.canada.ca%2Fenvironmental-indicators&source=datasetsearch",
                    "domain": null
                  }
                ]
              }
            }
          ]
        }
      ]
    }
  ]
}